#version 150

#moj_import <fog.glsl>
#moj_import <sign_dye_text_tools.glsl>
#moj_import <sign_dye_text_colours.glsl>

in vec3 Position;
in vec4 Color;
in vec2 UV0;
in ivec2 UV2;
in vec3 Normal;

uniform sampler2D Sampler2;
uniform float GameTime;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform int FogShape;

out float vertexDistance;
out vec4 vertexColor;
out vec2 texCoord0;

void main() {
    gl_Position = ProjMat * ModelViewMat * vec4(Position, 1.0);
    vertexDistance = fog_distance(Position, FogShape);

    vec4 col = Color;
    float vertDistance = 800;
    bool applyShading = true;

    if ( vertexDistance <= vertDistance && col.rgb == vec3(0.4, 0, 0) ) {
        // red sign text
        col.rgb = signColours[0];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(1, 0, 0) ) {
        // red sign text - glow outline
        col.rgb = signColours[1];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.4, 0.1607843137254902, 0.047058823529411764) ) {
        // orange sign text
        col.rgb = signColours[2];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(1, 0.40784313725490196, 0.12156862745098039) ) {
        // orange sign text - glow outline
        col.rgb = signColours[3];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.4, 0.4, 0) ) {
        // yellow sign text
        col.rgb = signColours[4];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(1, 1, 0) ) {
        // yellow sign text - glow outline
        col.rgb = signColours[5];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.2980392156862745, 0.4, 0) ) {
        // lime sign text
        col.rgb = signColours[6];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.7490196078431373, 1, 0) ) {
        // lime sign text - glow outline
        col.rgb = signColours[7];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0, 0.4, 0) ) {
        // green sign text
        col.rgb = signColours[8];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0, 1, 0) ) {
        // green sign text - glow outline
        col.rgb = signColours[9];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0, 0.4, 0.4) ) {
        // cyan sign text
        col.rgb = signColours[10];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0, 1, 1) ) {
        // cyan sign text - glow outline
        col.rgb = signColours[11];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.23921568627450981, 0.2980392156862745, 0.3215686274509804) ) {
        // light blue sign text
        col.rgb = signColours[12];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.6039215686274509, 0.7529411764705882, 0.803921568627451) ) {
        // light blue sign text - glow outline
        col.rgb = signColours[13];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0, 0, 0.4) ) {
        // blue sign text
        col.rgb = signColours[14];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0, 0, 1) ) {
        // blue sign text - glow outline
        col.rgb = signColours[15];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.25098039215686274, 0.047058823529411764, 0.3764705882352941) ) {
        // purple sign text
        col.rgb = signColours[16];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.6274509803921569, 0.12549019607843137, 0.9411764705882353) ) {
        // purple sign text - glow outline
        col.rgb = signColours[17];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.4, 0, 0.4) ) {
        // magenta sign text
        col.rgb = signColours[18];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(1, 0, 1) ) {
        // magenta sign text - glow outline
        col.rgb = signColours[19];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.4, 0.16470588235294117, 0.2823529411764706) ) {
        // pink sign text
        col.rgb = signColours[20];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(1, 0.4117647058823529, 0.7058823529411765) ) {
        // pink sign text - glow outline
        col.rgb = signColours[21];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.4, 0.4, 0.4) ) {
        // white sign text
        col.rgb = signColours[22];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(1, 1, 1) ) {
        // white sign text - glow outline
        col.rgb = signColours[23];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.32941176470588235, 0.32941176470588235, 0.32941176470588235) ) {
        // light grey sign text
        col.rgb = signColours[24];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.8274509803921568, 0.8274509803921568, 0.8274509803921568) ) {
        // light grey sign text - glow outline
        col.rgb = signColours[25];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.2, 0.2, 0.2) ) {
        // grey sign text
        col.rgb = signColours[26];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.5019607843137255, 0.5019607843137255, 0.5019607843137255) ) {
        // grey sign text - glow outline
        col.rgb = signColours[27];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0, 0, 0) ) {
        // black sign text
        col.rgb = signColours[28];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.9411764705882353, 0.9215686274509803, 0.8) ) {
        // black sign text - glow outline
        col.rgb = signColours[29];
    }

    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.21568627450980393, 0.10588235294117647, 0.027450980392156862) ) {
        // brown sign text
        col.rgb = signColours[30];
    }
    else if ( vertexDistance <= vertDistance && col.rgb == vec3(0.5450980392156862, 0.27058823529411763, 0.07450980392156863) ) {
        // brown sign text - glow outline
        col.rgb = signColours[31];
    }



    if(applyShading == true){
        vertexColor = col * texelFetch(Sampler2, UV2 / 16, 0);
    }
    else if(applyShading == false && vertexDistance > vertDistance){
        vertexColor = col * texelFetch(Sampler2, UV2 / 16, 0);
    }
    else if(applyShading == false){
        vertexColor = col;
    }

    texCoord0 = UV0;
}
